"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withConvertAdminrules2MachineVersion = exports.uploadupdateCertList = exports.setting_CustomRuleValidator = exports.parseAdminAccountFromJWToken = exports.accessRule = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _GKErrors_Inner = require("../class2api/GKErrors_Inner");

var _adminRuleValidator = _interopRequireDefault(require("./adminRuleValidator"));

var _loadConfig = _interopRequireDefault(require("./loadConfig.js"));

var _md = _interopRequireDefault(require("md5"));

var _isomorphicFetch = _interopRequireDefault(require("isomorphic-fetch"));

var _lodash = require("lodash");

var _excluded = ["req", "res", "__cacheManage", "___frontpageURL"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _getConfig = (0, _loadConfig["default"])(),
    sysName = _getConfig.name,
    admin_rule_center = _getConfig.admin_rule_center;

var _ruleValidator_custom;
/**
 * 权证验证起
 * @param jwtoken
 * @param ruleCategory
 * @param ruleName
 * @param ruleDesc
 * @param codePath
 * @returns {Promise.<*>}
 */


var ruleValidator =
/*#__PURE__*/
function () {
  var _ref2 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee(_ref) {
    var jwtoken, categoryName, categoryDesc, ruleName, ruleDesc, codePath, apiInvokeParams, frontReq, params;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            jwtoken = _ref.jwtoken, categoryName = _ref.categoryName, categoryDesc = _ref.categoryDesc, ruleName = _ref.ruleName, ruleDesc = _ref.ruleDesc, codePath = _ref.codePath, apiInvokeParams = _ref.apiInvokeParams, frontReq = _ref.frontReq;
            params = {
              jwtoken: jwtoken,
              categoryName: categoryName,
              categoryDesc: categoryDesc,
              ruleName: ruleName,
              ruleDesc: ruleDesc,
              codePath: codePath,
              apiInvokeParams: apiInvokeParams,
              frontReq: frontReq
            };

            if (!_ruleValidator_custom) {
              _context.next = 8;
              break;
            }

            _context.next = 5;
            return _ruleValidator_custom({
              sysName: sysName,
              jwtoken: jwtoken,
              categoryName: categoryName,
              categoryDesc: categoryDesc,
              ruleName: ruleName,
              ruleDesc: ruleDesc,
              codePath: codePath,
              frontReq: frontReq
            });

          case 5:
            return _context.abrupt("return", _context.sent);

          case 8:
            _context.next = 10;
            return _adminRuleValidator["default"]._ruleValidator_inner(_objectSpread2(_objectSpread2({}, params), {}, {
              sysName: sysName
            }));

          case 10:
            return _context.abrupt("return", _context.sent);

          case 11:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function ruleValidator(_x) {
    return _ref2.apply(this, arguments);
  };
}();
/**
 * accessRule访问权限修饰器中认证函数的全局配置入口
 *
 * @param ruleValidator
 */


var setting_CustomRuleValidator =
/*#__PURE__*/
function () {
  var _ref3 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee2(ruleValidator) {
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!(typeof ruleValidator !== "function")) {
              _context2.next = 2;
              break;
            }

            throw _GKErrors_Inner.GKErrors._PARAMS_VALUE_EXPECT("\u63D0\u4F9B\u7ED9setting_CustomRuleValidator\u7684\u53C2\u6570\u9700\u8981\u662FFunction\uFF0C\u800C\u4E0D\u662F".concat(_typeof(ruleValidator)));

          case 2:
            _ruleValidator_custom = ruleValidator;

          case 3:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function setting_CustomRuleValidator(_x2) {
    return _ref3.apply(this, arguments);
  };
}();
/**
 * 修饰器,提供访问权限的校验控制
 *
 * @returns {Function}
 */


exports.setting_CustomRuleValidator = setting_CustomRuleValidator;

var accessRule = function accessRule(options) {
  var categoryName = options.categoryName,
      ruleName = options.ruleName,
      _options$ruleDesc = options.ruleDesc,
      ruleDesc = _options$ruleDesc === void 0 ? '' : _options$ruleDesc;
  return function (target, name, descriptor) {
    //兼容babel 7的变化
    name = name || target.key;
    descriptor = descriptor || target.descriptor; // console.log( `accessRule:`  )
    // console.log( console.dir(target)  )
    // console.log( console.dir(name)  )
    // console.log( console.dir(descriptor)  )

    if (!ruleName) {
      //修饰器的报错，级别更高，直接抛出终止程序
      setTimeout(function () {
        throw new Error("\u5728\u7C7B\u9759\u6001\u65B9\u6CD5 ".concat(target.name, ".").concat(name, " \u4E0A\u6743\u9650\u63A7\u5236\u5668\u7684ruleName\u53C2\u6570\u672A\u5B9A\u4E49"));
      });
    } // console.log(`类静态方法 ${target.name}.${name}       上定义了权限点 =>      ${categoryName}.${ruleName} (${ruleDesc})`)


    var oldValue = descriptor.value;
    descriptor.value =
    /*#__PURE__*/
    _asyncToGenerator(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee3() {
      var Prod,
          hint,
          jwtoken,
          expressReq,
          apiModel,
          _arguments,
          _arguments$,
          apiParams0_Or_graphQLparent,
          graphQlparams,
          _arguments$2,
          ctx,
          info_nouse,
          req,
          request,
          apiInvokeParams,
          _expressReq,
          headers,
          cookies,
          frontReq,
          req_noused,
          res_noused,
          __cacheManage,
          ___frontpageURL_noused,
          _apiInvokeParams,
          _ref5,
          categoryName,
          categoryDesc,
          _ref6,
          err,
          result,
          canAccess,
          resean,
          _args3 = arguments;

      return _regenerator["default"].wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              if (target.__modelSetting) {
                _context3.next = 3;
                break;
              }

              //修饰器的报错，级别更高，直接抛出终止程序
              setImmediate(function () {
                throw new Error("\u9700\u8981\u65B9\u6CD5\u7EA7\u6743\u9650\u7BA1\u63A7\u7684\u540E\u53F0\u4E1A\u52A1\u7C7B".concat(target.name, "\uFF0C\u8FD8\u6CA1\u6709\u6DFB\u52A0modelSetting\u4FEE\u9970\u5668"));
              });
              throw new Error("error in class2api");

            case 3:
              if (!(typeof target.__modelSetting !== "function")) {
                _context3.next = 6;
                break;
              }

              //修饰器的报错，级别更高，直接抛出终止程序
              setImmediate(function () {
                throw new Error("\u540E\u53F0\u4E1A\u52A1\u7C7B".concat(target.name, "\u6240\u6DFB\u52A0\u7684modelSetting\u4FEE\u9970\u5668\u4E0D\u6B63\u786E\uFF0C\u8BF7\u53C2\u8003class2api\u6587\u6863"));
              });
              throw new Error("error in class2api");

            case 6:
              if (target.__modelSetting().__ruleCategory) {
                _context3.next = 9;
                break;
              }

              //修饰器的报错，级别更高，直接抛出终止程序
              setImmediate(function () {
                throw new Error("\u7C7B ".concat(target.name, " \u7684modelSetting\u4FEE\u9970\u5668\u4E2D\u6CA1\u6709\u6307\u5B9A__ruleCategory\u5C5E\u6027\uFF08\u6743\u9650\u7EC4\u4FE1\u606F\uFF09"));
              });
              throw new Error("error in class2api");

            case 9:
              //优先取PRODUCTION_TYPE，其次取NODE_ENV
              Prod = process.env.PRODUCTION_TYPE || process.env.NODE_ENV;

              if (!(Prod !== "production")) {
                _context3.next = 16;
                break;
              }

              hint = "\u975E\u6B63\u5F0F\u73AF\u5883(PRODUCTION_TYPE=".concat(process.env.PRODUCTION_TYPE, ", NODE_ENV=").concat(process.env.NODE_ENV, ", nextJS\u9879\u76EE\u8BC6\u522BPRODUCTION_TYPE\uFF0CAPI\u9879\u76EE\u8BC6\u522BNODE_ENV)\uFF0C\u4FBF\u4E8E\u8C03\u8BD5\uFF0C\u6388\u6743\u653E\u884C...");
              console.error(hint); //直接放行调用

              _context3.next = 15;
              return oldValue.apply(void 0, _args3);

            case 15:
              return _context3.abrupt("return", _context3.sent);

            case 16:
              apiModel = 'api'; //传统class2api，还是prisma-graphQL接口API
              //取值位置1：传统API方法的入参
              //取值位置2：graphQL版API方法的入参
              //两个位置同时取

              _arguments = Array.prototype.slice.call(_args3), _arguments$ = _arguments[0], apiParams0_Or_graphQLparent = _arguments$ === void 0 ? {} : _arguments$, graphQlparams = _arguments[1], _arguments$2 = _arguments[2], ctx = _arguments$2 === void 0 ? {} : _arguments$2, info_nouse = _arguments[3];
              req = apiParams0_Or_graphQLparent.req;
              expressReq = req;

              if (!expressReq) {
                request = ctx.request;
                expressReq = request;
                if (expressReq) apiModel = 'graphQL';
              }

              if (expressReq) {
                _context3.next = 23;
                break;
              }

              throw _GKErrors_Inner.GKErrors._NOT_ACCESS_PERMISSION("\u8EAB\u4EFD\u65E0\u6CD5\u8BC6\u522B\uFF0C\u5728API\u5BF9\u5E94\u7684\u9759\u6001\u65B9\u6CD5(".concat(target.name, ".").concat(name, ")\u7684\u5165\u53C2\u4E2D\u672A\u8BFB\u53D6\u5230\u8BF7\u6C42\u5934\u5BF9\u8C61\u7684cookie.jwtoken\u6216headers['jwtoken']\uFF0C\u8BF7\u54A8\u8BE2class2api\u7684\u7EF4\u62A4\u4EBA\u5458"));

            case 23:
              jwtoken = expressReq.cookies.jwtoken || expressReq.headers['jwtoken'] || "";

              if (jwtoken) {
                _context3.next = 26;
                break;
              }

              throw _GKErrors_Inner.GKErrors._NOT_ACCESS_PERMISSION("\u8EAB\u4EFD\u672A\u660E\uFF0C\u60A8\u6CA1\u6709\u8BBF\u95EE".concat(target.name, ".").concat(name, "\u5BF9\u5E94API\u63A5\u53E3\u7684\u6743\u9650"));

            case 26:
              //采集请求的日志信息
              apiInvokeParams = '';
              _expressReq = expressReq, headers = _expressReq.headers, cookies = _expressReq.cookies;
              frontReq = {
                ___ip: expressReq.headers['x-forwarded-for'] || expressReq.connection && expressReq.connection.remoteAddress || expressReq.socket && expressReq.socket.remoteAddress || expressReq.connection.socket && expressReq.connection.socket.remoteAddress || '',
                headers: headers,
                cookies: cookies
              };

              if (apiModel === "api") {
                //剔除传统API请求参数中多余的（由框架注入的杂质信息），剩余属性为调用的真实入参
                req_noused = apiParams0_Or_graphQLparent.req, res_noused = apiParams0_Or_graphQLparent.res, __cacheManage = apiParams0_Or_graphQLparent.__cacheManage, ___frontpageURL_noused = apiParams0_Or_graphQLparent.___frontpageURL, _apiInvokeParams = _objectWithoutProperties(apiParams0_Or_graphQLparent, _excluded);

                try {
                  apiInvokeParams = JSON.stringify(_apiInvokeParams);
                } catch (err) {
                  apiInvokeParams = 'call params stringify error';
                }
              } else {
                try {
                  apiInvokeParams = JSON.stringify(graphQlparams);
                } catch (err) {
                  apiInvokeParams = 'call params stringify error（graphQL）';
                }
              } //长度过长，截取前505位


              if (apiInvokeParams.length > 505) {
                apiInvokeParams = apiInvokeParams.substr(0, 500) + '[...]';
              }

              _ref5 = target.__modelSetting ? target.__modelSetting().__ruleCategory : {
                name: '无名',
                desc: '-'
              }, categoryName = _ref5.name, categoryDesc = _ref5.desc;
              _context3.next = 34;
              return ruleValidator({
                jwtoken: jwtoken,
                categoryName: categoryName,
                categoryDesc: categoryDesc,
                ruleName: "".concat(ruleName),
                ruleDesc: ruleDesc,
                codePath: "".concat(target.name, ".").concat(name),
                apiInvokeParams: apiInvokeParams,
                frontReq: frontReq
              });

            case 34:
              _ref6 = _context3.sent;
              err = _ref6.err;
              result = _ref6.result;
              canAccess = result.canAccess, resean = result.resean;

              if (canAccess) {
                _context3.next = 40;
                break;
              }

              throw _GKErrors_Inner.GKErrors._NOT_ACCESS_PERMISSION({
                resean: "\u8BBF\u95EE\u88AB\u62D2\u7EDD\uFF08\u529F\u80FD\uFF1A[".concat(categoryName, "/").concat(ruleName, "]\uFF0C\u4EE3\u7801:[").concat(target.name, ".").concat(name, "]\uFF0C\u539F\u56E0\uFF1A").concat(resean || '-', "\uFF09")
              });

            case 40:
              _context3.next = 42;
              return oldValue.apply(void 0, _args3);

            case 42:
              return _context3.abrupt("return", _context3.sent);

            case 43:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));
    return descriptor;
  };
};
/**
 * 从jstoken值解析后台管理用户的账号
 *
 * @param jstoken
 * @returns {Promise.<*>}
 */


exports.accessRule = accessRule;

var parseAdminAccountFromJWToken =
/*#__PURE__*/
function () {
  var _ref8 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee4(_ref7) {
    var jwtoken, req;
    return _regenerator["default"].wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            jwtoken = _ref7.jwtoken, req = _ref7.req;
            _context4.next = 3;
            return _adminRuleValidator["default"].parseAdminAccountFromJWToken({
              jwtoken: jwtoken,
              req: req
            });

          case 3:
            return _context4.abrupt("return", _context4.sent);

          case 4:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));

  return function parseAdminAccountFromJWToken(_x3) {
    return _ref8.apply(this, arguments);
  };
}();
/**
 * 将易于书写结构中的rules value值转换为对象结构
 * @param adminrules
 * @returns {Promise<void>}
 */


exports.parseAdminAccountFromJWToken = parseAdminAccountFromJWToken;

var withConvertAdminrules2MachineVersion = function withConvertAdminrules2MachineVersion(adminrules) {
  if ((typeof window === "undefined" ? "undefined" : _typeof(window)) === "object") {
    throw new Error("\u5927\u524D\u7AEF\u73AF\u5883\uFF0C\u8BF7\u4F7F\u7528 nexweb\u7EC4\u4EF6\u4E2D\u7684withConvertAdminrules2MachineVersion\u51FD\u6570");
  }

  (0, _lodash.keys)(adminrules).forEach(function (CategoryKey) {
    var RuleItem = adminrules[CategoryKey];
    var sysName = RuleItem.__sysName;
    (0, _lodash.keys)(RuleItem).forEach(function (key2) {
      return RuleItem[key2] = {
        categoryName: CategoryKey,
        ruleName: key2,
        ruleDesc: RuleItem[key2],
        sysName: sysName
      };
    });
    RuleItem.__ruleCategory = {
      name: CategoryKey,
      desc: ''
    };
    delete RuleItem.__sysName;
  });
  return adminrules;
};

exports.withConvertAdminrules2MachineVersion = withConvertAdminrules2MachineVersion;

var uploadupdateCertList =
/*#__PURE__*/
function () {
  var _ref10 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee5(_ref9) {
    var ruleCategory, ruleNameList, salt, timestamp, rawString, sign, res, _ref11, err, result;

    return _regenerator["default"].wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            ruleCategory = _ref9.ruleCategory, ruleNameList = _ref9.ruleNameList, salt = _ref9.salt;

            if (ruleNameList) {
              _context5.next = 3;
              break;
            }

            throw _GKErrors_Inner.GKErrors._NOT_PARAMS("ruleNameList");

          case 3:
            if (ruleCategory) {
              _context5.next = 5;
              break;
            }

            throw _GKErrors_Inner.GKErrors._NOT_PARAMS("ruleCategory");

          case 5:
            //验证签名
            timestamp = new Date().getTime();
            rawString = JSON.stringify({
              ruleNameList: ruleNameList,
              ruleCategory: ruleCategory,
              from: name,
              timestamp: timestamp
            });
            sign = (0, _md["default"])("".concat(salt, "-").concat(rawString, "-").concat(process.env.NODE_ENV));
            _context5.prev = 8;
            _context5.next = 11;
            return (0, _isomorphicFetch["default"])(admin_rule_center.register, {
              method: 'post',
              rejectUnauthorized: false,
              headers: {
                'Accept': 'application/json, text/plain, */*',
                'Content-Type': 'application/json'
              },
              withCredentials: 'true',
              json: true,
              body: JSON.stringify({
                ruleNameList: ruleNameList,
                ruleCategory: ruleCategory,
                from: name,
                timestamp: timestamp,
                sign: sign
              })
            });

          case 11:
            res = _context5.sent;
            _context5.next = 14;
            return res.json();

          case 14:
            _ref11 = _context5.sent;
            err = _ref11.err;
            result = _ref11.result;
            return _context5.abrupt("return", {
              err: err,
              result: result
            });

          case 20:
            _context5.prev = 20;
            _context5.t0 = _context5["catch"](8);
            console.error("\u6743\u9650\u70B9\u6CE8\u518C\u9047\u5230\u9519\u8BEF");
            console.error(_context5.t0.stack);

          case 24:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, null, [[8, 20]]);
  }));

  return function uploadupdateCertList(_x4) {
    return _ref10.apply(this, arguments);
  };
}();

exports.uploadupdateCertList = uploadupdateCertList;