"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.vlog_setting = exports.vlogSend = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _v = _interopRequireDefault(require("uuid/v4"));

var _VlogWorker = require("./VlogWorker.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var VlogWorker = __dirname + '/VlogWorker.js';

var _require = require('child_process'),
    fork = _require.fork;

var workerProcess;
var _apiUrl = '';
var _debugTrace = false;

var _secret;

var _sysName;

var start = function start() {
  workerProcess = fork(VlogWorker);
  workerProcess.on('close', function () {
    console.log("\u5B50\u8FDB\u7A0B\u610F\u5916\u7ED3\u675F\uFF0C\u6062\u590D\u8FD0\u884C ... ");
    console.dir(workerProcess);
    start();
  });
};

var vlog_setting = function vlog_setting(_ref) {
  var apiUrl = _ref.apiUrl,
      _ref$debugTrace = _ref.debugTrace,
      debugTrace = _ref$debugTrace === void 0 ? false : _ref$debugTrace,
      sysName = _ref.sysName,
      secret = _ref.secret;
  _apiUrl = apiUrl;
  _debugTrace = debugTrace;
  _sysName = sysName;
  _secret = secret;
  start();
};
/**
 * 发送日志
 * @param isProduction  是否为生产环境
 * @param sysName       业务方系统简称（二级域名的第一个单词缩写）
 * @param sourceHeaders 源请求req头
 * @param userIdentifier    用户标识
 * @param action            动作名称
 * @param targetType        操作目标
 * @param [time]            可选，动作事件的发生时间，默认为当前时间
 * @param targetID          操作目标的标识符
 * @param targetOwnerIdentifier 操作目标归属方的标识符
 * @param extraInfo         附加信息对象
 * @returns {Promise<void>}
 */


exports.vlog_setting = vlog_setting;

var vlogSend =
/*#__PURE__*/
function () {
  var _ref3 = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee(_ref2) {
    var _ref2$isProduction, isProduction, sysName, sourceHeaders, userIdentifier, action, targetType, _ref2$time, time, targetID, targetOwnerIdentifier, extraInfo;

    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _ref2$isProduction = _ref2.isProduction, isProduction = _ref2$isProduction === void 0 ? 1 : _ref2$isProduction, sysName = _ref2.sysName, sourceHeaders = _ref2.sourceHeaders, userIdentifier = _ref2.userIdentifier, action = _ref2.action, targetType = _ref2.targetType, _ref2$time = _ref2.time, time = _ref2$time === void 0 ? new Date() : _ref2$time, targetID = _ref2.targetID, targetOwnerIdentifier = _ref2.targetOwnerIdentifier, extraInfo = _ref2.extraInfo;

            if (_apiUrl) {
              _context.next = 3;
              break;
            }

            throw new Error("TransferVLog\u4E2D\u7684apiUrl\u5C1A\u672A\u914D\u7F6E\uFF0C\u8BF7\u5148\u8C03\u7528vlog_setting\u8BBE\u7F6E");

          case 3:
            if (_secret) {
              _context.next = 5;
              break;
            }

            throw new Error("TransferVLog\u4E2D\u7684secret\u5C1A\u672A\u914D\u7F6E\uFF0C\u8BF7\u5148\u8C03\u7528vlog_setting\u8BBE\u7F6E");

          case 5:
            if (_sysName) {
              _context.next = 7;
              break;
            }

            throw new Error("TransferVLog\u4E2D\u7684sysName\u5C1A\u672A\u914D\u7F6E\uFF0C\u8BF7\u5148\u8C03\u7528vlog_setting\u8BBE\u7F6E");

          case 7:
            if (!(typeof userIdentifier === "undefined" || typeof userIdentifier !== "string")) {
              _context.next = 9;
              break;
            }

            throw new Error("TransferVLog\u7684\u65E5\u5FD7\u53D1\u9001send\u8C03\u7528\uFF0C\u7F3A\u5C11 userIdentifier \u53C2\u6570 \u6216\u53C2\u6570\u4E0D\u662F\u5B57\u7B26\u4E32\u7C7B\u578B");

          case 9:
            if (!(typeof action === "undefined" || typeof action !== "string")) {
              _context.next = 11;
              break;
            }

            throw new Error("TransferVLog\u7684\u65E5\u5FD7\u53D1\u9001send\u8C03\u7528\uFF0C\u7F3A\u5C11 action \u53C2\u6570 \u6216\u53C2\u6570\u4E0D\u662F\u5B57\u7B26\u4E32\u7C7B\u578B");

          case 11:
            if (!(typeof targetType === "undefined" || typeof targetType !== "string")) {
              _context.next = 13;
              break;
            }

            throw new Error("TransferVLog\u7684\u65E5\u5FD7\u53D1\u9001send\u8C03\u7528\uFF0C\u7F3A\u5C11 targetType \u53C2\u6570 \u6216\u53C2\u6570\u4E0D\u662F\u5B57\u7B26\u4E32\u7C7B\u578B");

          case 13:
            if (!(typeof targetID === "undefined" || typeof targetID !== "string")) {
              _context.next = 15;
              break;
            }

            throw new Error("TransferVLog\u7684\u65E5\u5FD7\u53D1\u9001send\u8C03\u7528\uFF0C\u7F3A\u5C11 targetID \u53C2\u6570 \u6216\u53C2\u6570\u4E0D\u662F\u5B57\u7B26\u4E32\u7C7B\u578B");

          case 15:
            if (!(typeof time === "undefined" || typeof time !== "string")) {
              _context.next = 17;
              break;
            }

            throw new Error("TransferVLog\u7684\u65E5\u5FD7\u53D1\u9001send\u8C03\u7528\uFF0C\u7F3A\u5C11 time \u53C2\u6570 \u6216\u53C2\u6570\u4E0D\u662F\u5B57\u7B26\u4E32\u7C7B\u578B");

          case 17:
            if (!(_typeof(sourceHeaders) !== "object")) {
              _context.next = 19;
              break;
            }

            throw new Error("TransferVLog\u7684\u65E5\u5FD7\u53D1\u9001send\u8C03\u7528\uFF0C\u7F3A\u5C11 sourceHeaders \u53C2\u6570 \u6216\u53C2\u6570\u4E0D\u662Fobject\u7C7B\u578B");

          case 19:
            if (!(_typeof(extraInfo) !== "object")) {
              _context.next = 21;
              break;
            }

            throw new Error("TransferVLog\u7684\u65E5\u5FD7\u53D1\u9001send\u8C03\u7528\uFF0C\u7F3A\u5C11 extraInfo \u53C2\u6570 \u6216\u53C2\u6570\u4E0D\u662Fobject\u7C7B\u578B");

          case 21:
            if (_debugTrace) {
              console.log('vlogSend... ');
            } // workerProcess.send({


            _context.next = 24;
            return (0, _VlogWorker.doSendVlog)({
              _debugTrace: _debugTrace,
              _apiUrl: _apiUrl,
              _secret: _secret,
              _resendTimes: 0,
              //
              _uuid: (0, _v["default"])(),
              isProduction: isProduction === 1 || isProduction === '1' || isProduction === true ? 1 : 0,
              sysName: _sysName,
              userIdentifier: userIdentifier,
              action: action,
              targetType: targetType,
              targetID: targetID,
              time: time,
              targetOwnerIdentifier: targetOwnerIdentifier,
              extraInfo: extraInfo,
              sourceHeaders: sourceHeaders
            });

          case 24:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function vlogSend(_x) {
    return _ref3.apply(this, arguments);
  };
}();

exports.vlogSend = vlogSend;